How Many Answers Are Wrong HDU - 3038 (并查集)题解

题面:

    TT and FF are ... friends. Uh... very very good friends -________-b 

    FF is a bad boy, he is always wooing TT to play the following game with him. This is a very humdrum game. To begin with, TT should write down a sequence of integers-_-!!(bored). 


    Then, FF can choose a continuous subsequence from it(for example the subsequence from the third to the fifth integer inclusively). After that, FF will ask TT what the sum of the subsequence he chose is. The next, TT will answer FF's question. Then, FF can redo this process. In the end, FF must work out the entire sequence of integers. 

    Boring~~Boring~~a very very boring game!!! TT doesn't want to play with FF at all. To punish FF, she often tells FF the wrong answers on purpose. 

    The bad boy is not a fool man. FF detects some answers are incompatible. Of course, these contradictions make it difficult to calculate the sequence. 

    However, TT is a nice and lovely girl. She doesn't have the heart to be hard on FF. To save time, she guarantees that the answers are all right if there is no logical mistakes indeed. 

    What's more, if FF finds an answer to be wrong, he will ignore it when judging next answers. 

    But there will be so many questions that poor FF can't make sure whether the current answer is right or wrong in a moment. So he decides to write a program to help him with this matter. The program will receive a series of questions from FF together with the answers FF has received from TT. The aim of this program is to find how many answers are wrong. Only by ignoring the wrong answers can FF work out the entire sequence of integers. Poor FF has no time to do this job. And now he is asking for your help~(Why asking trouble for himself~~Bad boy) 
    Input
    Line 1: Two integers, N and M (1 <= N <= 200000, 1 <= M <= 40000). Means TT wrote N integers and FF asked her M questions. 

    Line 2..M+1: Line i+1 contains three integer: Ai, Bi and Si. Means TT answered FF that the sum from Ai to Bi is Si. It's guaranteed that 0 < Ai <= Bi <= N. 

    You can assume that any sum of subsequence is fit in 32-bit integer. 
    Output
    A single line with a integer denotes how many answers are wrong.
    Sample Input
    10 5
    1 10 100
    7 10 28
    1 3 32
    4 6 41
    6 6 1
    Sample Output
    1

题意描述:对一个序列给出多组形如第a个数到第b个数之和为c的句子,要求统计出错误句子的数量(前后矛盾),错误的句子会忽略掉不会对后面造成影响。

可以用并查集带一些拓展信息来做这道题,以前有写过图中使用并查集并维护点到父结点的距离,这题有点类似的意思,除了一个f[]数组,还有一个val[]数组维护点到父节点这段区间的数值和,并且需要最左边的结点作为父亲结点,所以对于一个句子the sum from a to b is c,如果a-1和b这两个结点的不在同一个连通块,说明前面没有句子约束这段区间的数值和,所以这是一句正确的句子,然后我们就可以让f[F(b)]=F(a-1),并同时维护更新val数组。

#include<iostream>
#include<cstdio>
#include<algorithm>
#include<string.h>
using namespace std;
typedef long long ll;
const int maxn = 200005;
int n,m;
int f[maxn];
int val[maxn];
int F(int x){
    if (f[x] == x)return x;
    int tt = F(f[x]);
    val[x] += val[f[x]];
    return f[x] = tt;
}

int main(){
    int u, v, w;
    while (~scanf("%d%d", &n, &m)){
        for (int i = 0; i <= n; i++)f[i] = i;
        memset(val, 0, sizeof(val));
        int ans = 0;
        for (int i = 0; i < m; i++){
            scanf("%d%d%d", &u, &v, &w);
            u--;
            int f1 = F(u);
            int f2 = F(v);
            if (f1 != f2){
                f[f2] = f1;
                val[f2] = val[u] - val[v] + w;
            }
            else{
                if (val[v] - val[u] != w)ans++;
            }
        }
        printf("%d\n", ans);  
    }
    return 0;
}
  • 1
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值